*     $ CREATE SOURCE.FOR
*     COPY SOURCE
*     
*===  source ===========================================================*
*     
      SUBROUTINE SOURCE ( NOMORE )

      INCLUDE '(DBLPRC)'
      INCLUDE '(DIMPAR)'
      INCLUDE '(IOUNIT)'
*     
*----------------------------------------------------------------------*
*     *
*     Copyright (C) 1990-2005      by    Alfredo Ferrari & Paola Sala  *
*     All Rights Reserved.                                             *
*     *
*     *
*     New source for FLUKA9x-FLUKA200x:                                *
*     *
*     Created on 07 january 1990   by    Alfredo Ferrari & Paola Sala  *
*     Infn - Milan       *
*     *
*     Last change on 17-jun-05     by    Alfredo Ferrari               *
*     *
*     This is just an example of a possible user written source routine.  *
*     note that the beam card still has some meaning - in the scoring the *
*     maximum momentum used in deciding the binning is taken from the     *
*     beam momentum.  Other beam card parameters are obsolete.            *
*     *
*----------------------------------------------------------------------*
*     
*     
*     
      INCLUDE '(BEAMCM)'
      INCLUDE '(FHEAVY)'
      INCLUDE '(FLKSTK)'
      INCLUDE '(IOIOCM)'
      INCLUDE '(LTCLCM)'
      INCLUDE '(PAPROP)'
      INCLUDE '(SOURCM)'
      INCLUDE '(SUMCOU)'
*     
      LOGICAL LFIRST,IPRINT
      EXTERNAL SPMUON
      REAL*4 SRC(1000,3)
      INTEGER NSRC,KST,KPT
      REAL*4 X1,X2,Y1,Y2,Z1,Z2,Z3,Z4
      REAL*4 FR(3),RFR(4)
      CHARACTER*80 DIRNAME
*     
      SAVE LFIRST,IPRINT
      SAVE SRC,NSRC,KST,KPT,X1,X2,Y1,Y2,Z1,Z2,Z3,Z4
      SAVE FR
      SAVE EPRMAX, EPRMIN, RADEMI, GAMMAS, EKNSAM, 
     &     COSZEN, KTPRNT
*     MV di spnorm
      COMMON / SPMBAT / GAMMAE, SPNORM, CSTHPR


*     MV Flusso angolare di macro per i Mu, passo 18 gradi a per
*     l'azimut (360/20)

      DIMENSION COSZEN(10,20)

      DATA (COSZEN( 1,K), K=1,20) /
     +     0.21840,   1.65740,   7.57470,   4.17650,   0.35700,
     +     0.00000,   0.00000,   0.00000,   0.00000,   0.00000,
     +     0.03870,   0.15470,   0.13260,   0.00000,   0.00000,
     +     0.00000,   0.00000,   0.46410,   0.00000,   0.00000
     +     /

      DATA (COSZEN( 2,K), K=1,20) /
     +     2.78820,  18.74230,  45.39810,  14.62530,   1.61380,
     +     0.03870,   0.03230,   0.08150,   0.01020,   0.02370,
     +     0.04300,   0.17310,   0.20220,   0.12260,   0.00970,
     +     0.00000,   0.01940,   0.07740,   0.03410,   0.05360
     +     /

      DATA (COSZEN( 3,K), K=1,20) /
     +     4.57570,  43.32700,  69.93220,  16.66080,   3.64950,
     +     0.56680,   2.54210,   1.01110,   0.08430,   0.11100,
     +     0.30750,   0.38400,   0.68250,   0.33270,   0.03910,
     +     0.05370,   0.04040,   0.16850,   0.01560,   0.18720
     +     /

      DATA (COSZEN( 4,K), K=1,20) /
     +     5.44720,  53.22120,  85.62850,  33.13240,   7.48010,
     +     6.19010,  11.96220,   8.91210,   3.39700,   0.54180,
     +     0.75900,   1.24560,   1.87070,   0.79220,   0.34070,
     +     0.80530,   0.59750,   0.31240,   0.08030,   0.33540
     +     /

      DATA (COSZEN( 5,K), K=1,20) /
     +     7.66290,  65.47390,  90.36740,  53.46340,  22.46010,
     +     19.93100,  35.05150,  33.08050,  23.64680,   7.51580,
     +     3.61840,   4.30650,   4.53930,   2.58340,   1.34070,
     +     2.58160,   1.64220,   0.53550,   0.36150,   0.73360
     +     /

      DATA (COSZEN( 6,K), K=1,20) /
     +     12.97260,  97.41630,  72.33360,  66.01840,  41.77260,
     +     33.09090,  55.99120,  78.93990,  57.14170,  44.45190,
     +     29.51570,  23.76620,  14.52710,   7.25590,   4.04420,
     +     4.93780,   5.41960,   1.64130,   0.63940,   0.83530
     +     /

      DATA (COSZEN( 7,K), K=1,20) /
     +     79.38730, 158.82170,  78.24050,  92.78530,  49.27310,
     +     45.61720,  69.60490, 112.86470, 137.65900, 108.12010,
     +     80.43210,  62.00810,  47.05410,  28.88970,  10.50390,
     +     10.60020,  10.85520,   6.43960,   1.45540,   5.70330
     +     /

      DATA (COSZEN( 8,K), K=1,20) /
     +     106.56380, 111.95780,  89.75130,  95.08940,  66.30300,
     +     61.05230, 113.16560, 157.94031, 166.02010, 151.82080,
     +     130.48460, 116.79500, 102.04410,  63.90190,  40.61970,
     +     30.99630,  18.87500,  14.76930,  27.75650,  79.00490
     +     /

      DATA (COSZEN( 9,K), K=1,20) /
     +     119.39220, 120.98620,  89.59670,  95.61810,  64.56030,
     +     81.41700, 114.92000, 145.13940, 179.35640, 173.14110,
     +     194.45010, 160.83940, 101.72860,  98.64620,  63.23090,
     +     42.84280,  30.51280,  29.05850,  47.09200, 106.55020
     +     /

      DATA (COSZEN(10,K), K=1,20) /
     +     101.92200, 100.55450,  91.89080,  70.83930,  72.94900,
     +     90.54650,  98.42050, 135.23180, 141.54201, 137.17191,
     +     140.91209, 160.61440, 102.75890, 103.39830,  75.41190,
     +     56.43350,  43.70730,  56.49960,  67.05570, 115.11140
     +     /
*     END MV

      DATA LFIRST / .TRUE. /
      DATA PGR/3.14159/
*======================================================================*
*     *
*     BASIC VERSION                                        *
*     *
*======================================================================*
      NOMORE = 0
*     +-------------------------------------------------------------------*
*     |  First call initializations:
      IF ( LFIRST ) THEN
*     |  *** The following 3 cards are mandatory ***
         TKESUM = ZERZER
         LFIRST = .FALSE.
         LUSSRC = .TRUE.
*     |  *** User initialization ***
*     |  *** Uniform source generation ***
*     WHASOU:
*     First line - SOURCE geometry and energy distribution
*     1: 0 - da BEAM , 1 - File, 2 - mu underground
*     2: 0 - P(X,Y,Z), 1 - Cyl(r,R,z1,z2,z3,z4), 2 - Box(x,X,y,Y,z1,z2,z3,z4)
*     3: X0	4: Y0	5: Z0  6: Xmin/Rmin	
*     Second line - SOURCE geometry Z:
*     7:Xmax/Rmax	8: Ymin	  9:Ymax  10: Z0   11: Z1  12: Z2   13: Z3
*     se 1 e' 0 o 1 leggi la geometria successiva 2 invece cambia ppiu' cose

	 IF( WHASOU(1).LT.0. ) IPRINT = .TRUE.
	 KPT = ABS(WHASOU(1))
*         OPEN ( 66, file = "musource.txt" )
	 IF( KPT.EQ.1 ) THEN
            NSRC = 1
            CALL GETENV('FLUDAT\0',DIRNAME)
            K=80
            DO WHILE( K.GT.1 .AND. DIRNAME(K:K).EQ.' ' )
               K = K-1
            END DO
            DIRNAME(K+1:K+1) = '/'
            DO L=1,8
               DIRNAME(K+L+1:K+L+1) = SDUSOU(L:L)
            END DO
            WRITE(6,*) 'SOURCE FILENAME: ',DIRNAME
            OPEN( UNIT=51,NAME=DIRNAME,ACCESS='SEQUENTIAL',
     &           TYPE='OLD',ERR=51)
*     SRC: 3 valori (bincenter [MeV], pdf, cdf) ordinati per bin
*     in futuro una funzione di sort e normalizzazione
 50         READ(51,*,ERR=52,END=52) (SRC(NSRC,K),K=1,3)
            IF( IPRINT ) WRITE(6,*) NSRC,(SRC(NSRC,K),K=1,3)
            NSRC = NSRC + 1
            GOTO 50
 51         WRITE(6,*) 'Error opening Source filename: ',DIRNAME
            CALL EXIT
 52         NSRC = NSRC - 1
            WRITE(6,*) 'Number of read source points: ',NSRC
            CLOSE( UNIT=51 )
            ENDIF
            IF (KPT.NE.2) THEN
            KST = WHASOU(2)
            X0 = WHASOU(3)
            Y0 = WHASOU(4)
            Z0 = WHASOU(5)
            IF( KST.NE.0 ) THEN
               X1 = WHASOU(6)
               X2 = WHASOU(7)
               Y1 = WHASOU(8)
               Y2 = WHASOU(9)
               Z1 = WHASOU(10)
               Z2 = WHASOU(11)
               Z3 = WHASOU(12)
               Z4 = WHASOU(13)
               IF( KST.EQ.1 ) THEN
                  FR(1) = PGR*X2*X2*(Z2-Z1)
                  FR(2) = PGR*(X2*X2-X1*X1)*(Z3-Z2)
                  FR(3) = PGR*X2*X2*(Z4-Z3)

      IF( IPRINT ) WRITE(6,*) 'Cylinder parameters: ',X1,X2,Z1,Z2,Z3,Z4
               ELSE IF( KST.EQ.2 ) THEN
                  FR(1) = X2*Y2*(Z2-Z1)
                  FR(2) = (X2*Y2-X1*Y1)*(Z3-Z2)
                  FR(3) = X2*Y2*(Z4-Z3)
                  RFR(1) = (Y2-Y1)*X2
                  RFR(2) = (X2-X1)*Y1
                  RFR(3) = RFR(1)
                  RFR(4) = RFR(2)
               END IF
            END IF
            TMP = 0.
            DO L=1,3
               TMP = TMP + FR(L)
            END DO
            IF( TMP.GT.0. ) THEN
               DO L=1,3
                  FR(L)= FR(L)/TMP
                  IF( L.GT.1 ) FR(L)= FR(L) + FR(L-1)
               END DO
            END IF
            IF( KST.EQ.2 ) THEN
               TMP = 0.
               DO L=1,4
                  TMP = TMP + RFR(L)
               END DO
               DO L=1,4
                  RFR(L)= RFR(L)/TMP
                  IF( L.GT.1 ) RFR(L)= RFR(L) + RFR(L-1)
               END DO
            END IF
*     |  |  MV Standard muon flux:
         ELSE IF ( KPT.EQ.2 ) THEN
*----------------------------------------------------------------------*
*     WHAT (2) = Starting radius R                                 *
*     WHAT (3) = Minimum energy                                    *
*     WHAT (4) = Maximum energy                                    *
*     WHAT (5) = Spectral index for sampling (below transition     *
*     energy)                                           *
*     WHAT (6) = Transition energy for sampling (above sample      *
*     from 1/E)                                         *
*----------------------------------------------------------------------*
            IFLXFL = 1
            GAMMAE = 3.5D+00
            RADEMI = WHASOU (2)
            EPRMIN = WHASOU (3)
            EPRMAX = WHASOU (4)
            GAMMAS = WHASOU (5)
            EKNSAM = WHASOU (6)
*     |  |  |
*     |  |  +-------------------------------------------------------------*
            CSTHPR = ONEONE
            FFACT = EXP(0.4D0*3.8D0)
            APRMAX = FFACT/((EPRMAX+540.D0)*FFACT-540.D0)**GAMMAE
            APRMIN = FFACT/((EPRMIN+540.D0)*FFACT-540.D0)**GAMMAE
            SPNORM = ONEONE/( GAMMAE - 1.D0 )* (
     &           1.D0/((EPRMIN+540.D0)*FFACT-540.D0)**(GAMMAE - 1.D0) -
     &           1.D0/((EPRMAX+540.D0)*FFACT-540.D0)**(GAMMAE - 1.D0) )
            WRITE (LUNOUT,*)' **** Spnorm:',SPNORM
            SPNORM = 1.D+00 / SPNORM
            WRITE(LUNOUT,*)' *** Real  spectral index:',SNGL(GAMMAE)
            WRITE(LUNOUT,*)' *** Starting radius:',SNGL(RADEMI),
     &           ' cm ***'
            WRITE(LUNOUT,*)' *** Minimum energy:',SNGL(EPRMIN),
     &           ' GeV ***'
            WRITE(LUNOUT,*)' *** Maximum energy:',SNGL(EPRMAX),
     &           ' GeV ***'
            SPCHCK = DGAUSS ( SPMUON, EPRMIN, EPRMAX, 1.D-10 )
            WRITE (LUNOUT,*)' **** Spchck:',SPCHCK
            BEAWEI = ONEONE
            KTPRNT = 500
*     |  | MV end muon FLUX
         END IF
      END IF
*     |
*     +-------------------------------------------------------------------*      
*     Push one source particle to the stack. Note that you could as well
*     push many but this way we reserve a maximum amount of space in the
*     stack for the secondaries to be generated
*     Lstack is the stack counter: of course any time source is called it
*     must be =0
      NPFLKA = NPFLKA + 1
*     Wt is the weight of the particle
      WTFLK  (NPFLKA) = ONEONE
      WEIPRI = WEIPRI + WTFLK (NPFLKA)
*     Particle type (1=proton.....). Ijbeam is the type set by the BEAM
*     card
c     IJBEAM: variabile per tipo di particella (BEAM: puo' essere sovrascritta qui)
*     +-------------------------------------------------------------------*
*     |  Heavy ion:
      IF ( IJBEAM .EQ. -2 ) THEN
         IJHION = IPROZ  * 1000 + IPROA
         IJHION = IJHION * 100 + KXHEAV
         IONID  = IJHION
         CALL DCDION ( IONID )
         CALL SETION ( IONID )
         ILOFLK (NPFLKA) = IJHION
*     |
*     +-------------------------------------------------------------------*
*     |  Normal hadron:
      ELSE
         IONID  = IJBEAM
         ILOFLK (NPFLKA) = IJBEAM
      END IF
      IF( KPT.EQ.2 ) THEN
         IJBEAM = 11
         IF(FLRNDM( DUMMY ).GT.0.45248869D0) IJBEAM = 10
         ILOFLK (NPFLKA) = IJBEAM
      END IF
*     |
*     +-------------------------------------------------------------------*
*     From this point .....
*     Particle generation (1 for primaries)
      LOFLK  (NPFLKA) = 1
*     User dependent flag:
      LOUSE  (NPFLKA) = 0
*     User dependent spare variables:
      DO 100 ISPR = 1, MKBMX1
         SPAREK (ISPR,NPFLKA) = ZERZER
 100  CONTINUE
*     User dependent spare flags:
      DO 200 ISPR = 1, MKBMX2
         ISPARK (ISPR,NPFLKA) = 0
 200  CONTINUE
*     Save the track number of the stack particle:
      ISPARK (MKBMX2,NPFLKA) = NPFLKA
      NPARMA = NPARMA + 1
      NUMPAR (NPFLKA) = NPARMA
      NEVENT (NPFLKA) = 0
      DFNEAR (NPFLKA) = +ZERZER
*     ... to this point: don't change anything
*     Particle age (s)
      AGESTK (NPFLKA) = +ZERZER
      AKNSHR (NPFLKA) = -TWOTWO
*     Group number for "low" energy neutrons, set to 0 anyway
      IGROUP (NPFLKA) = 0
*     Kinetic energy of the particle (GeV)
*     MV rinizia
c     E' PBEAM che va definito (imp. in GeV/c; qui si puo' sovrascrivere)
      IF( KPT.EQ.1 ) THEN
 300     RNDMV = FLRNDM( DUMMY )
         J=1
*     MV src ordinati per bin 
         DO WHILE( J.LT.NSRC .and. SRC(J,3).LT.RNDMV ) 
            J = J + 1
         END DO
C     IF( IPRINT ) WRITE(6,*) j
*     MV interpolazione lineare
         IF( J.GT.1 ) THEN
            E1 = SRC(J-1,1)
            E2 = SRC(J,1)
            V1 = SRC(J-1,3)
         ELSE
            E1 = SRC(J,1)
            E2 = SRC(J+1,1)
            V1 = SRC(J+1,3)
         END IF
         EK = (E1+(RNDMV-V1)/(SRC(J,3)-V1)*(E2-E1))*1.E-3
         IF( EK.LT.0.) goto 300
         TKEFLK(NPFLKA) = EK
c     Formula gia' bellechepronta per E(p)
c     mdv = mdv + 1
c     TKEFLK(NPFLKA) = 10.**(-mod(mdv,10))
c     write(7,*) TKEFLK(NPFLKA)
*     MV inversione
         PMOFLK (NPFLKA) = SQRT ( TKEFLK (NPFLKA) * ( TKEFLK (NPFLKA)
     &        + TWOTWO * AM (ILOFLK(NPFLKA)) ) )
         PBEAM = PMOFLK (NPFLKA)
c$$$      ELSE IF( KPT.EQ.2 ) THEN
c$$$***********************************************************
c$$$*     Estrae l' energia del mu underground
c$$$*     misurato da macro e interpolato con due esponenziali
c$$$*     e viene attenuata
c$$$***********************************************************
c$$$         RNSAMP = FLRNDM( DUMMY )
c$$$*     MV dove sta depth ?? prima la direzione poi depht
c$$$         FFACT  = EXP(0.4D+00*DEPTH)
c$$$         YE1=(EPRMIN+540.)*fFACT-540.
c$$$         YE2=(EPRMAX+540.)*fFACT-540.
c$$$         ENEMAX = ( YE1 )**(1.-GAMMAE)
c$$$         ENEMIN = ( YE2 )**(1.-GAMMAE)
c$$$         XENER=RNSAMP*(ENEMAX-ENEMIN) + ENEMIN
c$$$         ENE =  XENER**(1./(1.-GAMMAE))
c$$$         EKSAMP=((ene+540.)/ffact)-540.
c$$$*     Kinetic energy of the particle
c$$$         TKEFLK(NPFLKA) = EKSAMP
c$$$         write(7,*) TKEFLK(NPFLKA)
c$$$         PMOFLK (NPFLKA) = SQRT ( TKEFLK (NPFLKA) * ( TKEFLK (NPFLKA)
c$$$     &        + TWOTWO * AM (ILOFLK(NPFLKA)) ) )
c$$$         PBEAM = PMOFLK (NPFLKA)
      ELSE
*     Particle momentum
         PMOFLK (NPFLKA) = PBEAM
      TKEFLK (NPFLKA) = SQRT ( PBEAM**2 + AM (IONID)**2 ) - AM (IONID)
      END IF
************************************************************
*     Particle coordinates
      IF( KPT.LT.2 ) THEN
*     MV sovrascrive BEAM: estrae XBEAM, YBEAM, ZBEAM all'interno deo
*     volumi definiti
         IF( KST.EQ.0 ) THEN
            XBEAM = X0
            YBEAM = Y0
            ZBEAM = Z0
         ELSE IF( KST.EQ.1 ) THEN
            RNDMV = FLRNDM( DUMMY )
            NUMS = 1
            DO WHILE( RNDMV.GT.FR(NUMS) )
               NUMS = NUMS + 1
            END DO
            IF( NUMS.EQ.1 ) THEN
               RR = X2*SQRT(FLRNDM( DUMMY ))
               ZBEAM = Z0 + Z1 + (Z2-Z1)*FLRNDM( DUMMY )
            ELSE IF( NUMS.EQ.2 ) THEN
               RR = SQRT((X2*X2-X1*X1)*FLRNDM( DUMMY )+X1*X1)
               ZBEAM = Z0 + Z2 + (Z3-Z2)*FLRNDM( DUMMY )
            ELSE IF( NUMS.EQ.3 ) THEN
               RR = X2*SQRT(FLRNDM( DUMMY ))
               ZBEAM = Z0 + Z3 + (Z4-Z3)*FLRNDM( DUMMY )
            END IF
            PHI = 2.*PGR*FLRNDM( DUMMY )
            XBEAM = X0 + RR*SIN(PHI)
            YBEAM = Y0 + RR*COS(PHI)
            write(6,*) RNDMV,xbeam,ybeam,zbeam
         ELSE IF( KST.EQ.2 ) THEN
            RNDMV = FLRNDM( DUMMY )
            NUMS = 1
            DO WHILE( RNDMV.GT.FR(NUMS) )
               NUMS = NUMS + 1
            END DO
            IF( NUMS.EQ.1 ) THEN
               XBEAM = X0 + 2.*X2*FLRNDM( DUMMY ) - X2
               YBEAM = Y0 + 2.*Y2*FLRNDM( DUMMY ) - Y2
               ZBEAM = Z0 + Z1 + (Z2-Z1)*FLRNDM( DUMMY )
            ELSE IF( NUMS.EQ.2 ) THEN
               RNDMV = FLRNDM( DUMMY )
               NUMT = 1
               DO WHILE( RNDMV.GT.RFR(NUMT) )
                  NUMT = NUMT + 1
               END DO
               IF(NUMT.EQ.1) THEN
                  XBEAM = X0 + 2.*X2*FLRNDM( DUMMY ) - X2
                  YBEAM = Y0 + Y1 + (Y2-Y1)*FLRNDM( DUMMY )
               ELSE IF(NUMT.EQ.2) THEN
                  XBEAM = X0 + X1 + (X2-X1)*FLRNDM( DUMMX )
                  YBEAM = Y0 + 2.*Y1*FLRNDM( DUMMY ) - Y1
               ELSE IF(NUMT.EQ.3) THEN
                  XBEAM = X0 + 2.*X2*FLRNDM( DUMMY ) - X2
                  YBEAM = Y0 + -Y1 - (Y2-Y1)*FLRNDM( DUMMY )
               ELSE IF(NUMT.EQ.4) THEN
                  XBEAM = X0 - X1 - (X2-X1)*FLRNDM( DUMMX )
                  YBEAM = Y0 + 2.*Y1*FLRNDM( DUMMY ) - Y1
               END IF
               ZBEAM = Z2 + (Z3-Z2)*FLRNDM( DUMMY )
            ELSE IF( NUMS.EQ.3 ) THEN
               XBEAM = X0 + 2.*X2*FLRNDM( DUMMY ) - X2
               YBEAM = Y0 + 2.*Y2*FLRNDM( DUMMY ) - Y2
               ZBEAM = Z0 + Z3 + (Z4-Z3)*FLRNDM( DUMMY )
            END IF
         END IF
c$$$      ELSE IF( KPT.EQ.2 ) THEN
c$$$************************************************************
c$$$*     mu Particle coordinates 
c$$$************************************************************
c$$$         XBEAM = XXX * RADEMI + XINA
c$$$         YBEAM = YYY * RADEMI + YINA
c$$$         ZBEAM = ZZZ * RADEMI + ZINA
      END IF
************************************************************
*     MV estrae i coseni direttori
*     Cosines (tx,ty,tz)
*     Da BEAMPOS (0 0 1) (si puo' sovrascrivere qui)
************************************************************
      IF( KPT.EQ.2 ) THEN
C     
C     Estrae la distribuzione angolare dei mu undeground (in modo scorrelato
C     dall' energia, ma va bene cosi'), fra 0. e 90.
C     IL vettore COSZEN contiene la distr. angolare misurata al GS.
C     Il mu deve andare verso Z decrescenti. Cos(Zenith)>0
C     MV vedi depth prima
C     
         PMXSMP = +PIPIPI
         PMNSMP = -PIPIPI
*     +-- -----------------------------------------------------------------*
*     |
 345     CONTINUE
D     WRITE(*,*) 'Start Direction extraction'
*     MV generare sulla superficie di una sfera per
*     ottenere una distribizione angolare che riempie
*     uniformememnte il volume
*     
*     |   Random position direction:
         COSTH0 = FLRNDM( DUMMY )
         SINTH0 = SQRT ( ( ONEONE - COSTH0 ) * ( ONEONE + COSTH0 ) )
         THETA0 = ACOS (COSTH0)
         PHIPH0 = FLRNDM( DUMMY ) * ( PMXSMP - PMNSMP ) + PMNSMP
         SINPH0 = SIN  (PHIPH0)
         COSPH0 = COS  (PHIPH0)
*         CALL SFECFE (COSPH0,SINPH0)
C     |   These are the position versor components:
         XXX    = COSPH0 * SINTH0
         YYY    = SINPH0 * SINTH0
         ZZZ    = COSTH0

*     |   Now sample the direction versor:
         RNDSPE = FLRNDM( DUMMY )
         SNTH   = SQRT (RNDSPE)
         CSTH   = SQRT (ONEONE-RNDSPE)
* MV genera un angolo uniforme
         CALL SFECFE (SNPH,CSPH)
         TR     = -CSTH
         TP     = -SNTH*SNPH
         TT     = -SNTH*CSPH
*     MV i coseni direttori 
         IF ( SINTH0 .GT. ANGLGB ) THEN
            UBEAM = XXX*TR+(XXX*ZZZ*TT-YYY*TP)/SINTH0
            VBEAM = YYY*TR+(YYY*ZZZ*TT+XXX*TP)/SINTH0
            WBEAM = ZZZ*TR-SINTH0*TT
         ELSE
            UBEAM = TT
            VBEAM = TP
            WBEAM = ZZZ*TR
         END IF
************************************************************
*     mu Particle coordinates 
*     MV Xina e' una variabile per backward compatibility
************************************************************
         XBEAM = XXX * RADEMI + XINA
         YBEAM = YYY * RADEMI + YINA
         ZBEAM = ZZZ * RADEMI + ZINA
*     solo le particelle che vanno verso il basso ci interessano
         IF ( WBEAM .GT. ZERZER ) GO TO 345
       
         COSZ = -WBEAM
         ICZ  = INT(COSZ/0.1D+00)+ONEONE
*     select 60 deg. secondo l'accetanza di MACRO?
*     in realta' sono 66 deg perche' c'e' l'approx all'intero successivo
         IF(ICZ.LT.5) GO TO 345
         IF(ICZ.GT.10) ICZ = 10
*     Angolo Phi rispetto all' asse X (che in FLUKA e' il lato corto della hall)
         IF(VBEAM.EQ.0.D+00.and.UBEAM.EQ.0.D+00) THEN
            AZIX = 0.D+00
         ELSE
            AZIX = ATAN2(VBEAM,UBEAM) * 180.D+00/PIPIPI
         ENDIF
         IF(AZIX.LT.0.D+00) AZIX = AZIX + 360.D+00
*     Passaggio all' azimuth, tenendo conto che in FLUKA
*     l' asse Y punta verso il lato lungo della Galleria     
         AZI = 38.412D+00 - AZIX
         IF(AZI.LT.0.D+00) AZI = AZI + 360.D+00
         IAZI = INT(AZI/18.D+00)+ONEONE
         IF(IAZI.GT.20) IAZI = 20
*     estraggo da COSZEN con hit or miss, 194.4510 e' il massimo di coszen 
         YCZ = FLRNDM( DUMMY ) * 194.4501D+00
*     spostato, prima era prima di ROCK = GSROC
         ZENI = ACOS(COSZ)*180.D+00/PIPIPI
         IF(YCZ.GT.COSZEN(ICZ,IAZI)) GO TO 345
         tantx = UBEAM/WBEAM
         tanty = VBEAM/WBEAM
         ROCK = GSROC(ZENI,AZI)
         IF(ROCK.GT.1.5D+04.OR.ROCK.LT.0.D+00) ROCK=15000.D+00
*     MV calcolo della profondita', converte a quintali/cm^2 ?
         DEPTH = STROCK(ROCK)/1000.D+00
         IF(DEPTH.LT.0.) WRITE(*,*) ZENI,AZI,ROCK,DEPTH
***********************************************************
*     MV Estrae l' energia del mu underground
*     misurato da macro e interpolato con due esponenziali
*     e viene attenuata
*     PDG - cosmic rays pag 24
***********************************************************
         RNSAMP = FLRNDM( DUMMY )
         FFACT  = EXP(0.4D+00*DEPTH)
         YE1=(EPRMIN+540.)*fFACT-540.
         YE2=(EPRMAX+540.)*fFACT-540.
         ENEMAX = ( YE1 )**(1.-GAMMAE)
         ENEMIN = ( YE2 )**(1.-GAMMAE)
         XENER=RNSAMP*(ENEMAX-ENEMIN) + ENEMIN
         ENE =  XENER**(1./(1.-GAMMAE))
         EKSAMP=((ENE+540.)/FFACT)-540.
*     Kinetic energy of the particle
         TKEFLK(NPFLKA) = EKSAMP
*         write(7,*) TKEFLK(NPFLKA)
         PMOFLK (NPFLKA) = SQRT ( TKEFLK (NPFLKA) * ( TKEFLK (NPFLKA)
     &        + TWOTWO * AM (ILOFLK(NPFLKA)) ) )
         PBEAM = PMOFLK (NPFLKA)
*        write(66,'(7f12.4)')  XBEAM, YBEAM, ZBEAM, ZENI,AZI, ROCK,
*     &  PBEAM 
*     MV se non sono mu genero uniforme
      ELSE
         CALL UNIDIR( UBEAM,VBEAM,WBEAM )
      END IF
      TXFLK  (NPFLKA) = UBEAM
      TYFLK  (NPFLKA) = VBEAM
      TZFLK  (NPFLKA) = WBEAM
*     TZFLK  (NPFLKA) = SQRT ( ONEONE - TXFLK (NPFLKA)**2
*     &                       - TYFLK (NPFLKA)**2 )
*     Polarization cosines:
      TXPOL  (NPFLKA) = -TWOTWO
      TYPOL  (NPFLKA) = +ZERZER
      TZPOL  (NPFLKA) = +ZERZER
*     Particle coordinates
c     Definite in BEAMPOS possono essere sovrascritte qui
c     WRITE(6,*) 'sourcetest: ',XBEAM,YBEAM,ZBEAM,
c     &	TKEFLK(NPFLKA),UBEAM,VBEAM,WBEAM
      XFLK   (NPFLKA) = XBEAM
      YFLK   (NPFLKA) = YBEAM
      ZFLK   (NPFLKA) = ZBEAM
      IF( IPRINT ) THEN
         ICNT = ICNT + 1
         WRITE(6,*) ICNT,TKEFLK(NPFLKA),XFLK(NPFLKA),YFLK(NPFLKA),
     &        ZFLK(NPFLKA)
      END IF
*     *  Calculate the total kinetic energy of the primaries: don't change
      IF ( ILOFLK (NPFLKA) .EQ. -2 .OR. ILOFLK (NPFLKA) .GT. 100000 )
     &     THEN
         TKESUM = TKESUM + TKEFLK (NPFLKA) * WTFLK (NPFLKA)
      ELSE IF ( ILOFLK (NPFLKA) .NE. 0 ) THEN
         TKESUM = TKESUM + ( TKEFLK (NPFLKA) + AMDISC (ILOFLK(NPFLKA)) )
     &        * WTFLK (NPFLKA)
      ELSE
         TKESUM = TKESUM + TKEFLK (NPFLKA) * WTFLK (NPFLKA)
      END IF
*     Flag this is prompt radiation
      LRADDC (NPFLKA) = .FALSE.
      RADDLY (NPFLKA) = ZERZER
*     Here we ask for the region number of the hitting point.
*     NREG (NPFLKA) = ...
*     The following line makes the starting region search much more
*     robust if particles are starting very close to a boundary:
      CALL GEOCRS ( TXFLK (NPFLKA), TYFLK (NPFLKA), TZFLK (NPFLKA) )
      CALL GEOREG ( XFLK  (NPFLKA), YFLK  (NPFLKA), ZFLK  (NPFLKA),
     &     NRGFLK(NPFLKA), IDISC )
*     Do not change these cards:
      CALL GEOHSM ( NHSPNT (NPFLKA), 1, -11, MLATTC )
      NLATTC (NPFLKA) = MLATTC
      CMPATH (NPFLKA) = ZERZER
      CALL SOEVSV
      RETURN
*===  End of subroutine Source =========================================*
      END

      SUBROUTINE UNIDIR( X,Y,Z )
      
      INCLUDE '(DBLPRC)'

      PHI = 2.0*PIPIPI*FLRNDM( DUMMY )
      Z = 2.0*FLRNDM( DUMMY ) - 1.0
      T = SQRT( 1.0-Z*Z )
      X= T*COS(PHI)
      Y = T*SIN(PHI)
      
      RETURN
      END
